end clear memory
comp freq = 4
cal 1950 1 freq
allocate 2001:freq

open data pc_data_003.xls
data(for=excel, org=col)
close data

set infl_dri = 100*freq*log(punew/punew{1})
set infl_xfe = 100*freq*log(puxx/puxx{1})
set shocks_ssw = 100*freq*( .66*log(pw1100/pw1100{1})+.34*log(pw1300/pw1300{1}) )-infl_dri
stat(noprint) shocks_ssw
set shocks_ssw = shocks_ssw - %mean
set un = lhur
* lhurm, lhmu25
set infl = infl_dri
* infl_xfe
diff infl / dinfl
diff un / dun

comp sh_lags = 3 

smpl 1962:1 2001:freq
* print 

* BENCHMARK
linreg dinfl / resids
# constant un{1 to 4} dinfl{1 to 12} shocks_ssw{1 to 1} nixon
displa %rss

* White's HetSced Test
set unun = un{1}*un{1}
set dinfdinf = dinfl{1}*dinfl{1}
set dinfun = dinfl{1}*un{1}
set res2 = resids**2
lin res2
# constant un{1} dinfl{1} unun dinfdinf dinfun
comp chist=%nobs*%rsquared
cdf chisqr chist 5
dis %rsquared
dis %nobs

linreg dinfl
# constant dinfl{1 to 24}

linreg dinfl 
# constant un{1 to 4} dinfl{1 to 4} shocks_ssw{0 to 2} nixon


linreg dinfl 
# constant un{1 to 12} dinfl{1 to 12} dinfl{16} shocks_ssw{1 to 3}
linreg(noprint) un
# constant un{1 to freq}
disp "standard dev of resids--un: " sqrt(%rss/%nobs)

linreg(noprint) dinfl
# constant dinfl{1 to freq}
disp "standard dev of resids--dinfl: " sqrt(%rss/%nobs)

*========================================================================================*
* Info Criteria   (slightly modified from akaike.prg)
*========================================================================================*
comp p_bar = 12
declare rect aic(p_bar,p_bar) bic(p_bar,p_bar)

cmom
# constant dinfl{1 to p_bar} un{1 to p_bar} shocks_ssw{1 to sh_lags} nixon dinfl
linreg(cmom, noprint) dinfl
# constant dinfl{1} un{1} shocks_ssw{1} nixon

display '   Lags of Infl   Lags of Un  Akaike         Schwarz'
do maxlag_infl=1,p_bar
    do maxlag_un=1,p_bar
        linreg(cmom,noprint) dinfl
        # constant dinfl{1 to maxlag_infl} un{1 to maxlag_un} shocks_ssw{1 to sh_lags} nixon
          compute akaike  = %nobs * log(%rss) + 2*%nreg
          compute schwarz = %nobs * log(%rss) + %nreg*log(%nobs)
          comp aic(maxlag_infl,maxlag_un) = akaike
          comp bic(maxlag_infl,maxlag_un) = schwarz
         display @5 #### maxlag_infl @20 #### maxlag_un @35 ####.#### akaike @50 schwarz
          * uncomment the previous line if you want to display all info functions
    end do
end do
disp ''
disp 'Optimal value of AIC:'  %minvalue(aic)  '   Optimal value of BIC:'  %minvalue(bic)



*================================================================================
* IMPULSE RESPONSES i don't think these are alright
*================================================================================

comp nsteps = 40 
comp neqn =2
declare rect[series] imps1(neqn,neqn)
declare vect[series] scaled(neqn)
declare vect[labels] implabel(neqn)

comp implabel=|| $
'Change Inflation', $
'Unemployment' ||

system(model=dinflUn)
variables dinfl un
lags 1 to 4
det constant
end(system)

estimate

list ieqn = 1 to neqn
smpl 1 to nsteps

impulse(model=dinflUn, result=imps1,noprint) * nsteps

*do i=1,neqn
*	comp header='IR to 1% Shock to' + implabel(i)
*	do j=1,neqn
*   		set scaled(j) = (imps1(j,i))
*	end do j
*        graph(header=header,key=below,klabels=implabel,window='to_'+implabel(i)) neqn
*	cards scaled(ieqn)
*end do i

DO I=1,NEQN
  COMPUTE HEADER='Plot of Responses to '+IMPLABEL(I)
  DO J=1,NEQN
     SET SCALED(J) = (IMPS1(J,I))
  END DO J
  GRAPH(HEADER=HEADER,KEY=BELOW,KLABELS=IMPLABEL,NUMBER=0,WINDOW='TO_'+IMPLABEL(I)) NEQN
  CARDS SCALED(IEQN)
END DO I

*================================================================================
equation pc dinfl
# constant un{0} dinfl{1 to 2} 
equation pc2 un
# constant un{0}
system(model=dinflUn2) pc pc2
end(system)

estimate

open plot corrs.rgf
corr(partial=dinflpcorrs,number=35) dinfl / dinflcorrs
graph(key=below,style=bar,nodates,min=-1.0,max=1.0,number=1) 2
# dinflcorrs 2 36
# dinflpcorrs 2 36

linreg dinfl
#constant dinfl{1 to 4} un{1 to 4}
