function y = aggr(x,freqAct,freqDes,method);
%  method 1 levels (like CPI)--deletes observations
%  method 2 levels (like CPI)--averages observations
%  method 3 growth rates -- approx, sums
%  method 4 growth rates -- exact

T =size(x,1); freqRatio=freqAct/freqDes;
if freqRatio~=round(freqRatio); error('Frequencies have to be divisible.'); end;
            
switch method;   
case 1; % levels -- deletion
    y=x(1:freqRatio:end,:);
case 2; % levels -- averaging
    ma=filter(ones(1,freqRatio)/freqRatio,1,x);  % moving average
    y=ma(freqRatio:freqRatio:end,:);
case 3; % approx growths
    sumx=filter(ones(1,freqRatio),1,x); 
    y=sumx(freqRatio:freqRatio:end,:);
case 4; % exact growths
    x=log(1+x/100);
    logx=(filter(ones(1,freqRatio),1,x));
    y=exp(logx(freqRatio:freqRatio:end,:));
    y=(y-1)*100;
end;
