
function [xbp, sebp] = bpassar(X,updc,lpdc,n,nar,tcode,seflag,per,filterIndex,q);
%  AFTER STOCK AND WATSON'S GAUSS PROCEDURES  --note need to finish st
%  errors for C-F and HP
% /* bpassar.prc -- Bandpass with AR padding for ends */
% /* -- input:
%       x = series to be filtered
%       updc = Period corresponding to upper cutoff frequency
%       lpdc = Period corresponding to lower cutoff frequency
%       n = number of terms in moving average filter
%       nar = order of AR used for padding
%       tcode = transformation code for AR model
%               0 -- no transformation
%               1 -- first difference
%       seflag == flag for standard errors (associated with endpoint problem)
%               0 -- no SEs computed
%               1 -- SEs computed
%       per     # periods per year
%       filterIndex  1 -- Baxter - King 
%                    2 -- Christiano - Fitzgerald
%                    3 -- HP
%                    4 -- one-sided HP
%       q   variance for 1sHP (not necessary)
%       Output is filtered value of series and standard errors
% */
xbp=repmat(nan,size(X)); sebp=xbp;
for i=1:size(X,2);
    x=X(:,i); ind=~isnan(x); x=x(ind);
%@ -- Pad Series -- @
if tcode == 0; xtran=x; end;
if tcode == 1; xtran=diff(x); end;
xpad=padAR2(x,xtran,tcode,n,nar);

%@ -- Bandpass Padded Series -- @
switch filterIndex
    case 1;
		xpadf = bpass(xpad,updc,lpdc,n);
		xbp1=xpadf(n+1:length(xpadf)-n); if lpdc<=2; xbp1=x-xbp1; end;
		if seflag == 1; sebp1(:,i)=sebpass(x,xtran,tcode,n,nar,updc,lpdc); else; sebp1=repmat(nan,length(xbp1),1); end;
    case 2;
        xpadf = bpass2(xpad,updc,lpdc);
        xbp1=xpadf(n+1:length(xpadf)-n); if lpdc<=2; xbp1=x-xbp1; end;
        sebp1=repmat(nan,length(xbp1),1);
    case 3;
        if per==1; lambda=1000; elseif per==12; lambda=14400; else lambda=160000; end; 
        xpadf = hpf(xpad,lambda);
        xbp1=xpadf(n+1:length(xpadf)-n);
        sebp1=repmat(nan,length(xbp1),1);
    case 4;
        if nargin==9; q=.000625; end;
        [cycle, xpadf]=detrendHP(xpad,per,q); % .000625 for Q
        xbp1=xpadf(n+1:length(xpadf)-n);
        sebp1=repmat(nan,length(xbp1),1);
    end;
    xbp(ind,i)=xbp1; sebp(ind,i)=sebp1; 
end;