function [f,act,fitted]=foreTVnru(yFore,XFore,fixWindInd);
%
% generates recursive out-of-sample AR(lags) forecasts of x
% fixWindInd   0 increasing window, non0 fixed window

if nargin==2; fixWindInd=0; end;
startVal=40; printIndex=0;
T=length(yFore); window=startVal;
rollNumb=T-startVal-1; f=repmat(nan,rollNumb,1); rollE=f; act=f;
for i=1:rollNumb; 
    startObs=(fixWindInd==0)+(fixWindInd~=0)*i;
    [f(i),rollE(i),act(i)]=rollFuncAR(startObs,startVal+i,XFore,yFore);    
end; 
%f(startVal+2+lags:startVal+rollNumb+lags+1)=rollF;
if printIndex;
if fixWindInd; lab='Fixed'; else; lab='Increasing'; end;
    fprintf(['MSE of Forecasts, ' lab ' Window:  %3.3f\n'],mean(rollE.^2)); 
end;
%f(2:startVal+lags+2)=XFore(1:startVal+lags+1); 
betaAllS=XFore\yFore; sum(betaAllS(1:4));
fitted=XFore*betaAllS; fitted=fitted(startVal+1:startVal+rollNumb);

%==========================================================================
function [rollF,rollE,rollAct]=rollFuncAR(regStart,regEnd,X,y);
yRoll=y(regStart:regEnd); rollAct=y(regEnd+1);
Xroll=X(regStart:regEnd,:); Xlast=X(regEnd+1,:); 
betaRoll(:,1)=pinv(Xroll'*Xroll)*Xroll'*yRoll; 
% Forecasts and Forecast Errors
rollF=Xlast*betaRoll;
rollE=rollF-rollAct;
   