function [AF,PF,AS,PS,mu,F]=getKlmNru(theta,y,X);
%
% filtered and smoothed estimates of the state variable and its variance 

theta=makeCol(theta); nobs=length(y);
u=y-X*theta(1:end-2);

Z=zeros(2); Z(1)=-theta(2);
T=eye(2); T(3)=1;
H=theta(end); Q=zeros(unLags); Q=zeros(2); Q(1)=lambda(1)*theta(end); Q(4)=lambda(2)*theta(end);

mu=repmat(nan,nobs,1); F=mu; atgtm1=repmat(nan,2,nobs); atgt=atgtm1; atgT=atgt;
ptgtm1=repmat(nan,[2,2,nobs]); ptgt=ptgtm1; ptgT=ptgt; J=ptgt;
for t = 1:nobs;
    % Prediction
    if t==1; atgtm1(:,t)=repmat(0,2,1); ptgtm1(:,:,t)=zeros(2); ptgtm1(1,1,1)=1; 
    else; atgtm1(:,t)=T*atgt(:,t-1); ptgtm1(:,:,t)=T*ptgt(:,:,t-1)*T'+Q; 
    end;
    % Updating
    mu(t) = u(t) - Z'*atgtm1(:,t);
    F(t) = Z'*ptgtm1(:,:,t)*Z+H;
    atgt(:,t) = atgtm1(:,t)+ptgtm1(:,:,t)*Z*pinv(F(t))*mu(t);
    ptgt(:,:,t) = ptgtm1(:,:,t)-ptgtm1(:,:,t)*Z*pinv(F(t))*Z'*ptgtm1(:,:,t);
end;

% Smoother
atgT(:,nobs)=atgt(:,nobs); ptgT(:,:,nobs)=ptgt(:,:,nobs);
for t= 1:nobs-1;
    J(:,:,nobs-t)=ptgt(:,:,nobs-t)*T'*pinv(ptgtm1(:,:,nobs-t+1));
    atgT(:,nobs-t) = atgt(:,nobs-t)+J(:,:,nobs-t)*(atgT(:,nobs-t+1)-atgtm1(:,nobs-t+1));
    ptgT(:,:,nobs-t) = ptgt(:,:,nobs-t)+J(:,:,nobs-t)*( ptgT(:,:,nobs-t+1)-ptgtm1(:,:,nobs-t+1) )*J(:,:,nobs-t)';
end;

AF=atgt(1,:)'+theta(1)/sum(Z);
PF=squeeze(ptgt(1,1,:));
AS=atgT(1,:)'+theta(1)/sum(Z);
PS=squeeze(ptgT(1,1,:));
