function [lda,ldaR,tau,tauR]=mubNru(y,X,pVal);
% 
% calculates the median unbiased estimator of noise variance in the Stock &
% Watson JASA 98 model; assumes X contains only constants
% y the series,
% arOrd  order of AR polynomial to use to fit to residuals
% pVal p value for the CI (.5: median, 0.025,0975 95% CI)
% mleIndex  do you want to do MLE (only simple RW + noise model-no AC in y)
%
%  OUTPUT:  lda: lambda
%           tau  tau  (variance)
% Note the table was obtained (by Stock and Watson) by Monte Carlo 
% => empirical cdf's are not increasing in lambda for each p value
%
enY=length(y); pVal=1-pVal; swcdf=load('G:\newNairu\programs\data\mub\swcdf.txt'); 
[QLR,QLRR,]=myQLR(y,X(:,2:end),X(:,1),.15,1,3,.05,1,(1:length(y))')
lda=repmat(nan,1,length(pVal)); ldaR=lda;

for i=1:length(pVal); % Lookup the CI's
   tar=pVal(i);
   [colm colI]=min(abs(tar-swcdf(1,2:end)));
   [rowm rowI]=min(abs(QLR(1)-swcdf(2:end,colI+1)));
   [rowmR rowIR]=min(abs(QLRR(1)-swcdf(2:end,colI+1)));
   if rowm>1; rowI=1; end; if rowmR>1; rowIR=1; end; 
   lda(i)=swcdf(rowI+1, 1); ldaR(i)=swcdf(rowIR+1, 1);
end;
b=X\y; e=y-X*b; sige=std(e);
tau=lda*sige/enY; tauR=ldaR*sige/enY;
