function [beta,ssrUnrestr,degreesOfFrdm,se,e,seOLS,ftstat,ftname]=nairuRegSpli3(inpSpl);
mmv2struct(inpSpl); % this unpacks the structure inpSpl
% Regressions
degreesOfFrdm=size(X,1)-size(X,2); 
beta=X\y; e=y-X*beta; stError = sum(e.^2)/degreesOfFrdm; ssrUnrestr=sum(e.^2);
unSpread=unLags(2)-unLags(1);
seOLS=(stError*pinv(X'*X));
%figure(1); plot(e); title('Residuals--Unrestricted Regression');
%axis([-Inf Inf 1.1*min(e) 1.1*max(e)]); acf(e,25,1);
rErrorsSign=sign(rErrors);
switch rErrorsSign;
    case -1;
        se=(stError*pinv(X'*X));  fprintf('OLS Standard Errors\n');
    case 0;
        wse_beta=hwhite_mine(y,X); fprintf('White Het Robust Standard Errors\n');
        se=wse_beta.V;
    case 1;
        se=nwest_mine(y,X,rErrors); se=se.V; 
        fprintf('Newey-West HAC Standard Errors, %2.0f Lags\n',rErrors);
end;   
varResDvarY=ssrUnrestr/sum((y-mean(y)).^2);
rsq(1,1)=1-varResDvarY; rsq(2,1)=1-varResDvarY*(size(X,1)-1)/degreesOfFrdm; 
if splineIndex==1; xlag=zeros(1,splineOrder+knots+1); else xlag=0; end;
xlag=[xlag,unLags(1):unLags(2),inLags(1):inLags(2)]'; 
labs=strvcat(repmat('un',unLags(2),1),repmat('dinfl',inLags(2),1));
labStore{1}='shocks'; labStore{2}='nixon';
if size(nLags,2)>2; j=1;
   for i=3:size(nLags,2); xlag=[xlag;(nLags(1,i):nLags(2,i))']; 
      labs=strvcat(labs,repmat(labStore{j},nLags(2,i)-nLags(1,i)+1,1)); j=j+1;   
   end;
end;

labs=strvcat(labels5(splineIndex,knots,splineOrder),labs);
[ftstat,ftname]=regprint(beta,labs,xlag,se,e,1,length(y),rsq);

%% Heteroscedasticity
%=========================================================================
if splineIndex==1; Xex=[X(:,1) X(:,knots+splineOrder+2:end)];    
   Xsmall=[X(:,1) X(:,knots+splineOrder+2) X(:,unSpread+knots+splineOrder+2)];
else Xex=X; Xsmall=[X(:,1) X(:,2) X(:,unSpread+2)]; end;
[whStat,whPval,engStat,engPval] = hetsced(Xex,e,4);
fprintf('Heteroscedasticity:   White''s stat:  %5.5f,    P value:   %8.8f\n',whStat,whPval);
fprintf('                      Engle''s stat:  %5.5f,    P value:   %8.8f\n',engStat,engPval);
[whStat2,whPval2,engStat2,engPval2] = hetsced(Xsmall,e,4);
fprintf('Heteroscedasticity:   White''s stat:  %5.5f,    P value:   %8.8f    (un and pie only)\n',...
   whStat2,whPval2);
%% Figure
% figure;
% subplot(2,2,1); plot(e,'.');title('Residuals'); liteGB=[171,219,224]/255; axis tight; axis 'auto y';
% subplot(2,2,2); [ac,bb]=acf2(e,20,0); h=bar(ac); set(h,'FaceColor',liteGB); title('ACF of Residuals'); 
% hold on; plot(bb,':k'); plot(-bb,':k'); hold off; axis tight; axis 'auto y';
% subplot(2,2,3); e2=e.^2; plot(e2,'.'); title('Squared Residuals'); axis tight; axis 'auto y';
% subplot(2,2,4); [ac2,bb2]=acf2(e2,20,0); h2=bar(ac2); set(h2,'FaceColor',liteGB); 
% title('ACF of Squared Residuals'); hold on; plot(bb2,':k'); plot(-bb2,':k'); 
% axis tight; axis 'auto y'; hold off; 
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y=labels5(splineIndex,knots,splineOrd);
splinLabs='const         ';
if splineIndex==1; 
   for i=1:splineOrd; splinLabs=strvcat(splinLabs,strcat('t^',int2str(i))); end;
   for i=1:knots; splinLabs=strvcat(splinLabs,strcat('t^',int2str(splineOrd),' i',int2str(i+1),'+')); end;
end
y=splinLabs;
