
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; close all; initSeed; tic; fprintf('\n'); diaryName=['.\out\' mfilename '.out']; % delete(diaryName); 
diary(diaryName); fprintf('\n\n\n\n\n');
disp('==================================================================================');
disp(['Running  ' mfilename '.m                      ' datestr(now)]); format compact; tic;
disp('==================================================================================');

% Baseline Quarterly
%==========================================================================
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
robTable=repmat(nan,10,7); robTable(:,1)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

% AR Expectations
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=3;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=figure; subplot(321); kalmanGraph2New; ttt=title('AR Expectations'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,2)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

% Bandpass
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=5;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=open('.\figs\bigFig.fig'); subplot(322); kalmanGraph2New; ttt=title('Bandpass'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,3)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

% Mnfctrg
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
prodIndex=2;
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=open('.\figs\bigFig.fig'); subplot(325); kalmanGraph2New; ttt=title('Manufacturing'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,6)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

% GDP Deflator
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
inflIndex=3;
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=open('.\figs\bigFig.fig'); subplot(323); kalmanGraph2New; ttt=title('GDP Deflator'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,4)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

% CPI X
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
inflIndex=2;
nruProdLambda=.01; 
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=open('.\figs\bigFig.fig'); subplot(324); kalmanGraph2New; ttt=title('CPI X'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,5)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');


% Unemployment Men 25-54
%==========================================================================
save('.\figs\yearEnd','yearEnd'); 
clear all;
paramsFileName='params'; load(['.\data\' paramsFileName]);  
frequency=4;
inflExpIndex=1;     % inflation expectations: 1 random walk, 2 AR forecasts, 3 AR forecasts in differences 
prodIndKF=1;        % productivity transform variable in the state eqn of KF: 1 diff, 2 diffdiff, 3 diff & diffdiff, 4 level, 5 level bandpass
prodLambda=.005;  
nruLambda=0.03; 
unIndex=3;
nruProdLambda=.01;
shoxLags=[1 1]';  
unLags=[1 4]';
inflLags=[1 4]'; 
mainNairuFuncNew;
bigFig=open('.\figs\bigFig.fig'); subplot(326); kalmanGraph2New; ttt=title('Unemployment Men 25-54'); set(ttt,'fontsize',7); saveas(bigFig,'.\figs\bigFig','fig');
load(['.\figs\robTable' int2str(yearEnd)]); robTable(:,7)=resTable(:,3); save(['.\figs\robTable' int2str(yearEnd)],'robTable');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
t=toc; mints=floor(toc/60); secs=toc-60*mints;
fprintf('Time: %4.0f minutes, %4.2f seconds\n',mints,secs); diary off;
