%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; close all; initSeed; tic; fprintf('\n')
disp('==================================================================================');
disp(['Running  ' mfilename '.m' ]); format compact; tic;
disp('==================================================================================');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
frequency=4;
prodIndex=1; % include productivity as a driving variable in RW?
prodLbda=.2;
nruLbda=.8;
keyIndex=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
inflLags=[1; 2]; unLags=[0; 0]; prodLags=[0; 0]; allLags=[unLags inflLags prodLags]; maxLags=max(max(allLags));
rErrors=2;
k=4;
dataFileName='intlData';
dataFile=load(['.\data\' dataFileName '.txt']);
labs=['Jap';'Ger';'Fra';'GBr';'Can';'Ita';'Net';'Swe']; fullLab=strvcat('Japan','Germany','France','Great Britain','Canada','Italy','Netherlands','Sweden');
transDataProdAll2; ttt=time(3:end); ttt=ttt(diff(unLags)+1:end);
if keyIndex; keyboard; end;

ASp2=repmat(nan, length(un)-2,size(un,2)); AFp2=ASp2;
for i=1:size(un,2);
    disp('*******************************************************************************************');
    disp(['Country:   ', fullLab(i,:)]);
    disp('*******************************************************************************************');
    un2=un(3:end,i); ind=min(~isnan([un2 dinfl(:,i) prd(2:end,i)]'))'; 
    un2=un2(ind); dinfl2=dinfl(ind,i); prd2=prd([logical(0); ind],i);
    options=[];
    [varEst,fval,exitflag,output] = fminsearch(@urwLik,[12,1],options,prd2); 
    fprintf([ labs(i,:) '  Prod Man Variances :  %4.4f    %4.4f  lambda:  %2.3f\n'],varEst(1)^2,varEst(2)^2,prodLbda);
    var1=varEst(1).^2*[1,prodLbda]; [AF,PF,ASp,PS] = urwState(var1,prd2); ASp2(ind,i)=ASp; AFp2(ind,i)=AF; prodVar=(ASp);
    x=[un2 dinfl2 [prodVar]]; z=mklagsMine(x,allLags); X=z.xl; X=[ones(length(X),1) X]; y=dinfl2(maxLags+1:end);
    regPr;
	kalmanData=X(:,1:end-diff(prodLags)-1); zVars=X(:,end-diff(prodLags):end);
	initGuess=kalmanData\y; varGuess=var(y-kalmanData*initGuess);
    if prodIndex;
	    mleEstimates=[initGuess; varGuess; .2]; kalmanHandle=@klmNruProd; smoothHandle=@getKlmNruProd;
    else; mleEstimates=[initGuess; varGuess]; kalmanHandle=@klmNru; smoothHandle=@getKlmNru; end;
	options=optimset('MaxFunEvals',300*length(mleEstimates)); exitflag=0;
	for j=1:5; 
        if exitflag==0;
            if prodIndex; [mleEstimates(:,j+1),fval,exitflag,output] = fminsearch(kalmanHandle,mleEstimates(:,j),options,y,kalmanData,zVars,diff(unLags)+1,nruLbda)
            else; [mleEstimates(:,j+1),fval,exitflag,output] = fminsearch(kalmanHandle,mleEstimates(:,j),options,y,kalmanData,diff(unLags)+1,nruLbda)
            end;
        end;
	end;
    [junk,indM]=max(ind);
    mleEstimates2=mleEstimates(:,end); ind2=[logical(zeros(indM-1,1)); ind(maxLags+indM:end)]; % if sum(~ind)>0; ind2(1:sum(~ind))=0; end;
    if prodIndex; [AFpc,PFpc,ASpc(ind2,i),PSpc]=feval(smoothHandle,[mleEstimates2;nruLbda*mleEstimates(end-1)],y,kalmanData,zVars,diff(unLags)+1);
    else; [AFpc,PFpc,ASpc(ind2,i),PSpc]=feval(smoothHandle,[mleEstimates2;nruLbda*mleEstimates(end)],y,kalmanData,diff(unLags)+1);
    end;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Figures
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ASpc(ASpc==0)=nan; f1=figure; f2=figure;
for i=1:size(un,2);
    figure(f1); subplot(4,2,i); h=myPlot(time(maxLags+3:end),[ASpc(:,i) ASp2(maxLags+1:end,i) un(maxLags+3:end,i) infl(maxLags+2:end,i)]); 
    ttt=title(['Productivity and the NAIRU ' fullLab(i,:)]); set(ttt,'fontsize',8); set(gca,'fontsize',6);
    axis([-inf inf 0 15]); set(h,'linewidth',1);
    if i==1; lll=legend('NAIRU','Productivity','Unemployment','Inflation');  set(lll,'fontsize',8); end; 
    figure(f2); subplot(4,2,i); h=myPlot(time(maxLags+3:end),[ASp2(maxLags+1:end,i) AFp2(maxLags+1:end,i)]); 
    ttt=title(['Productivity ' fullLab(i,:)]); set(ttt,'fontsize',8); set(gca,'fontsize',6);
    axis([-inf inf 0 15]); set(h,'linewidth',1);
    if i==1; lll=legend('Smoother','Filter');  set(lll,'fontsize',8); end; 
end;

% 
% figure; myPlot(time,ASP(:,[2 7])); legend('Ger','U.S.'); title('Productivity');
% figure; myPlot(time,xbpP(:,[1 2 7])); title('Productivity P'); legend(legendTitle([1 2 7],:));
% figure; myPlot(time,xbpP(:,[3:5])); title('Productivity P'); legend(legendTitle([3:5],:));
% figure; h=myPlot(time,un(2:end,[1:3 6])); title('Unemployment'); legend(legendTitle([1:3 6],:),2); set(h(3),'linestyle','-');
% figure; h=myPlot(time,un(2:end,[4 5 7])); title('Unemployment'); legend(legendTitle([4 5 7],:),2); set(h(3),'linestyle','-');
% figure; myPlot(time2,ASa); legend(labs); title('Productivity in Manufacturing');
% %figure; myPlot(time2,prodG); title('Productivity Growth in Manufacturing'); legend(labs,0);
% %figure; myPlot(time2,xbp); title('Productivity Growth in Manufacturing'); legend(labs,0);
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t=toc; mints=floor(toc/60); secs=toc-60*mints;
fprintf('Time: %4.0f minutes, %4.2f seconds\n',mints,secs); diary off;

